<!-- Beispiel-PHP-Script fr die NettalkIRCD Statistik - (c)2004 by Nicolas Kruse -->
<?PHP

define ("VALUE_SIZE", 32);
define ("LINE_SIZE", VALUE_SIZE * 2);
define ("VALUE_COUNT", 512);

define ("FILE_PATH", "Chanstat.dat"); // <-----**Hier den Pfad festlegen

//---- **Statistik ffnen
setupdstat(FILE_PATH, "#".@$_GET['channel']);

function setupdstat($filepath, $channel)
{
	$fs = filesize($filepath);
	$fp = fopen ($filepath,"r");
	
	if (strlen($channel) == 1 || $channel == "#list")
	{
		$counti = 0;
		for ($i = 0; $i < $fs; $i = $i + LINE_SIZE * VALUE_COUNT)
		{
			fseek($fp, $i);
			$dat = fread ($fp, VALUE_SIZE);
			$statarr[$counti] = rtrim($dat);
			$counti = $counti + 1;
		}
		sort($statarr);
		drawlist($statarr);
	}
	else
	{
		for ($i = 0; $i < $fs; $i = $i + LINE_SIZE * VALUE_COUNT)
		{
			fseek($fp, $i);
			$dat = fread($fp, VALUE_SIZE);
			if(strtoupper(rtrim($dat)) == strtoupper($channel)) break;
		}
		if ($i+2 < $fs)
		{
			$counti = 0;
			$maxtwc = 0;
			$maxtlc = 0;
			for ($i2 = $i + LINE_SIZE; $i + (VALUE_COUNT - 1) * LINE_SIZE; $i2 = $i2 + LINE_SIZE)
			{
				fseek($fp, $i2);
				$dat = fread($fp, VALUE_SIZE);
				if(ord(substr($dat, 0, 1)) == 0) break;
				$tempnick = rtrim($dat);
				$dat = fread($fp, VALUE_SIZE);
				if (ord(substr($dat, 0, 1)) == 0) break;
			    $statarr[0][$counti] = rtrim(substr($dat,0,16));
			    $statarr[1][$counti] = rtrim(substr($dat,16,16));
			    $statarr[2][$counti] = $tempnick;
			    if ($statarr[0][$counti] > $maxtwc) $maxtwc = $statarr[0][$counti];
			    if ($statarr[1][$counti] > $maxtlc) $maxtlc = $statarr[1][$counti];
			    $counti = $counti + 1;
			}
			array_multisort ($statarr[0], SORT_NUMERIC, SORT_DESC, $statarr[1], SORT_STRING, SORT_ASC, $statarr[2], SORT_STRING, SORT_ASC);
			drawstat($statarr, $maxtwc, $maxtlc, $channel);
		}
		else
		{
			echo("<h1>Chat-Statistik</h1><br>Keine Eintrge vorhanden");
		}
	}
	fclose($fp);
}

//*---------------------------------- ** Ausgabe der Raumliste ** ----------------------------------*

function drawlist($channels)
{
	echo("<h1>Verfgbaren Statistiken:</h1><br>\n");
	for($i = 0; $i < count($channels); $i = $i + 1)
	{
		echo($channels[$i]."<br>\n");
	}
}


//*---------------------------------- ** Ausgabe der Statistik ** ----------------------------------*

function drawstat($users, $maxwc, $maxlc, $channel)
{
	echo("<h1>Statistik von $channel</h1><br>\n");
	for($i = 0; $i < count($users[0]); $i = $i + 1)
	{
		echo("- ".$users[2][$i]." ".$users[0][$i]." ".$users[1][$i]."<br>\n");
	}
}
//*----------------------------------------------------------------------------------------*
?>